function task0(file)
    lines =
        eachline(file) .|>
        (x -> match(r"(?<x1>\d+),(?<y1>\d+) -> (?<x2>\d+),(?<y2>\d+)", x)) .|>
        (p -> (x1 = parse(Int, getindex(p, "x1")) + 1,
            y1 = parse(Int, getindex(p, "y1")) + 1,
            x2 = parse(Int, getindex(p, "x2")) + 1,
            y2 = parse(Int, getindex(p, "y2")) + 1)) |>
        x -> filter(l -> l.x1 == l.x2 || l.y1 == l.y2, x)

    xmax = map(l -> max(l.x1, l.x2), lines) |> maximum

    ymax = map(l -> max(l.y1, l.y2), lines) |> maximum

    mappe = zeros(Int, (xmax, ymax))

    for line in lines
        
        mappe[min(line.y1, line.y2):max(line.y1, line.y2),
            min(line.x1, line.x2):max(line.x1, line.x2)] .+= 1
        
    end

    sum(mappe .>= 2)
end

##

println("Day 05 – Task 1 – Case 0")
open(task0, "day05\\data\\case00.txt") |> display

println("Day 05 – Task 1 – Case 1")
open(task0, "day05\\data\\case01.txt") |> println

##

using LinearAlgebra

function task1(file)
    lines =
        eachline(file) .|>
        (x -> match(r"(?<x1>\d+),(?<y1>\d+) -> (?<x2>\d+),(?<y2>\d+)", x)) .|>
        (p -> (x1 = parse(Int, getindex(p, "x1")) + 1,
            y1 = parse(Int, getindex(p, "y1")) + 1,
            x2 = parse(Int, getindex(p, "x2")) + 1,
            y2 = parse(Int, getindex(p, "y2")) + 1))

    xmax = map(l -> max(l.x1, l.x2), lines) |> maximum

    ymax = map(l -> max(l.y1, l.y2), lines) |> maximum

    mappe = zeros(Int, (xmax, ymax))

    for line in lines
        
        if line.x1 == line.x2 || line.y1 == line.y2
            mappe[min(line.y1, line.y2):max(line.y1, line.y2),
                min(line.x1, line.x2):max(line.x1, line.x2)] .+= 1

        else
            mappe[min(line.y1, line.y2):max(line.y1, line.y2),
                min(line.x1, line.x2):max(line.x1, line.x2)] +=
                Matrix{Int}(I, abs(line.x1 - line.x2) + 1, abs(line.y1 - line.y2) + 1) |>
                ((line.x2 - line.x1) / (line.y2 - line.y1) > 0 ? identity : rotl90)
        end
        
    end

    sum(mappe .>= 2)
end

##

println("Day 05 – Task 2 – Case 0")
open(task1, "day05\\data\\case00.txt") |> display

println("Day 05 – Task 2 – Case 1")
open(task1, "day05\\data\\case01.txt") |> println
